****************************************
*	 Prozenummer = 1
*	 Delay = 4000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 3020001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--GOLD
'
'###############################################################
'#                        ADwGCNT.inc                          #
'#              INCLUDE-file for ADwin-GOLD-system             #
'###############################################################
'#                                                             #
'# Contents: Include functions for ADwin-GOLD-CO1              #
'#                                                             #
'#  22.06.1999  HM   creation                                  #
'#  21.03.2000  JK   extracted : INC PAR_14  ,  multiple reads #
'#                   and latches at CNT_READ (marked with OLD1)#
'#  10.04.2000  JK   header of this file (the first 13 lines)  #
'#                   again inserted, to avoid problems when    #
'#                   editing this file with the ADbasic editor #
'#  28.11.2000  JK   OLD1 comments deleted ; improved comment  #
'#                   for CNT_READLATCH                         #
'#  16.11.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  14.08.2002  JK   cntnr   ->  (cntnr)                       #
'#  02.06.2003  MF   CNT_GETSTATUS,CNT_RESETSTATUS,CNT_SE_DIFF #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#                                                             #
'###############################################################


' ************************************************************
SUB CNT_CLEAR(cntselect) 
' clear all counters selected with a bit 1
	POKE(20400310h,cntselect)
ENDSUB


' ************************************************************
SUB CNT_ENABLE(cntselect) 
' enable all counters selected with a bit 1
	POKE(20400300h,cntselect)
ENDSUB


' ************************************************************
SUB CNT_MODE(cntselect) 
' Select Counter-mode  (0 = CLK external, 1 = CLK internal(PWM))
	POKE(20400340h,cntselect)
ENDSUB


' ************************************************************
SUB CNT_SET(cntselect) 
' Set Counter   (0 = 4fach, 1 = CLK/DIR)
' Set PWM-Counter Frequency (0 = 20 MHz, 1 = 5 MHz)
	POKE(20400350h,cntselect)
ENDSUB


' ************************************************************
SUB CNT_INPUTMODE(cntselect) 
' Set Counterinputline   (0 = Clear counter, 1 = latch counter)
	POKE(20400330h,cntselect)
ENDSUB


' ************************************************************
SUB CNT_LATCH(cntselect) 
' latch all counters selected with a Bit 1
	POKE(20400320h,cntselect)
ENDSUB


' ***********************************************************
FUNCTION CNT_READ(cntnr) AS long
' performs a software-latch and reads the selected counter
' ATTENTION : this function may NOT be used, if the latch is
' done by an external signal (e.g. period-time or pulse 
' width measurements) !
	DIM cadr AS INTEGER
	DIM cntsel AS INTEGER
	cntsel = SHIFT_LEFT(1,(cntnr-1))
	POKE(20400320h, cntsel)
	cadr = 204001F4h + (cntnr) * 16	' parentheses because i + 1
																	' could be passed as cntnr
	CNT_READ = PEEK(cadr)
	' (we do not need multiple reads, because for software
	' latch the synchronisation is done by hardware.)    
ENDFUNCTION


' ***********************************************************
FUNCTION CNT_READLATCH(cntnr) AS long
' reads the latch register triggerd by software-latch or 
' signal-rise (of an external signal)
	DIM cadr AS INTEGER
	DIM ih AS INTEGER
	cadr = 204001F4h + (cntnr) * 16	' parentheses because i + 1
																	' could be passed as cntnr
	CNT_READLATCH = PEEK(cadr)

 ' case a : the latch register is triggered by a software- latch :
 ' ---------------------------------------------------------------
 ' In this case, there is no need for multiple reads, because 
 ' the synchronisation is done by hardware (see also the 
 ' comments at CNT_READ()). The following instructions are 
 ' not necessary, but they also do not harm (except wasting
 ' time). Therefore they are a potential for speed optimi-
 ' sations.

 ' case b : the latch register is triggered by an external signal :
 ' ----------------------------------------------------------------
 ' Check, if there was a (from an external signal triggered)
 ' LATCH just in the moment, when we read the latch 
 ' (This is neccessary because this case is not
 ' handled by the hardware).
 ' If we have this case, the second reading of the latch 
 ' register differs from the first reading and therefore 
 ' one of the readings may be corrupt. Read a third time to 
 ' be sure to have a valid reading. 
 '   The measured time for these three readings is 25 
 '   cycles = 625 ns   => the (period) time between two
 '   successive (external signal triggered) LATCHs may 
 '   NOT be shorter than this limit.
 '   => valid measurements (using this method with LATCH
 '   done by external signal) cannot be guaranteed for 
 '   smaller LATCH (period) times than 625 ns. (Longtime 
 '   tests were done and o.k. with 664 ns). To have a  
 '   safety margin for future changes in the ADbasic  
 '   compiler, our statement to the customer is the  
 '   limit of 1000 ns. 

	ih = PEEK(cadr)
	IF (ih <> CNT_READLATCH) THEN
		CNT_READLATCH = PEEK(cadr)
	ENDIF
ENDFUNCTION


' ***********************************************************
FUNCTION CNT_READFLATCH(cntnr) AS long
' reads the latch register triggerd by signal-falling edge
	DIM cadr AS INTEGER
	DIM ih AS INTEGER
	cadr = 204001F8h + (cntnr) * 16	' parentheses because i + 1
																	' could be passed as cntnr
	CNT_READFLATCH = PEEK(cadr)
	' (please see comments to READLATCH)
	ih = PEEK(cadr)
	IF (ih <> CNT_READFLATCH) THEN
		CNT_READFLATCH = PEEK(cadr)
	ENDIF
ENDFUNCTION


'***************************************************************
' reads the status of a counter input 
'***************************************************************
FUNCTION CNT_GETSTATUS() AS long
	CNT_GETSTATUS = PEEK(20400370h)           
ENDFUNCTION


'**************************************************************
' resets the error bits of the status register
'**************************************************************
SUB CNT_RESETSTATUS() AS long
	POKE(20400370h,0)
ENDSUB


'***************************************************************
' Selects single-ended (s.e.) or differential (diff.) inputs
' select: s.e. -> 0 (default after power-up),  diff. -> 1 
' counter 1,2 selected with Bit 0
' counter 3,4 selected with Bit 1
'***************************************************************
SUB CNT_SE_DIFF(select) as long
	POKE(20400304h,select)
ENDSUB

