****************************************
*	 Prozenummer = 1
*	 Delay = 150
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwpDIO.inc                          #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definitions of functions and procedures           #
'#           to access digital modules.                        #
'#                                                             #
'#  25.10.1996  OL   creation                                  #
'#  08.04.1998  MAH  Adaption for T9 (ADbasic 3)               #
'#  23.09.1999  JK   DIG_WRITELATCH32  (problems with SYNCALL) #
'#  16.11.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  10.12.2001  MF   CO4                                       #
'#  17.01.2002  MF   C04_GetStatus                             #
'#  31.01.2002  MF   CO4                                       #
'#  23.07.2002  MF   CO4 new synclatch / dir softwarelatch     #
'#  29.07.2002  MF   DIO32                                     #
'#  02.09.2002  MG   T10                                       #
'#  06.11.2003  RRa  STORAGE                                   #
'#  15.01.2004  MF   COMP16                                    #
'#  28.01.2004  RRa  bugfix, RTC_SET()                         #
'#  11.03.2004  RRa  bugfix, MEDIA_WFR()                       #
'#  29.03.2004  RRa  bugfix, store/load FLOATs to/from MEDIA   #
'#  28.04.2004  RRa  SUB added: RTC_GET()                      #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#                                                             #
'###############################################################


'***************************************************************
' The hardware adresses depend on the CPU module 
'***************************************************************
#IF PROZESSOR = T9 THEN
  #define DL         20400000H
  #define DH         20400010H
  #define DLX        20400020H
  #define DHX        20400030H
  #define D32        20400180H
  #define D32I       20400198H
  #define ADWR       20400060H
  #define ADRD       20400070H
  #define cpu_EVENT  204000F0H
  #define watchdog   204001D0H
  #define WD_TIMER   204001E0H
  #define cpu_LED    204001F0H
#ELSE
	#IF PROZESSOR = T10 THEN
	  #define DL         20800000H
	  #define DH         20800010H
	  #define DLX        20800020H
	  #define DHX        20800030H
	  #define D32        20800180H
	  #define D32I       20800198H
	  #define ADWR       20800060H
	  #define ADRD       20800070H
	  #define cpu_EVENT  208000F0H
	  #define watchdog   208001D0H
	  #define WD_TIMER   208001E0H
	  #define cpu_LED    208001F0H
	#ELSE
	  #define DL               00H
	  #define DH               10H
	  #define DLX              20H
	  #define DHX              30H
	  #define ADWR             60H
	  #define ADRD             70H
	  #define cpu_EVENT       0F0H
	  #define watchdog        1D0H
	  #define WD_TIMER        1E0H
	  #define cpu_LED         1F0H
	#ENDIF
#ENDIF

'***************************************************************
' Procedure inserts 5 nops after the poke order, if the processor
' is a T9. 
'***************************************************************

SUB poke_nop(adress,value)
#IF PROZESSOR = T9 THEN
   poke(adress,value)
   nops(5)
#ELSE
	#IF PROZESSOR = T10 THEN
   poke(adress,value)	 
	 nops(10)  
	#ELSE
   poke(adress,value)
	#ENDIF
#ENDIF
ENDSUB



'***************************************************************
' Procedure inserts 1 nop if the processor is a T9. 
'***************************************************************

SUB NOP_T9()
  #IF PROZESSOR = T9 THEN
    NOP
  #ENDIF
  #IF PROZESSOR = T10 THEN
    NOP
		NOP
  #ENDIF
ENDSUB

'***************************************************************
' If the processor is a T9 this prcedure disables the interrupt,
' so that a process with low priority can not be interrupted.
' The procedure is used to protect a read or a write cycle.
'***************************************************************
SUB SUB_BEGIN_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      BEGIN_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB

'***************************************************************
' This procedure enables the interrupt.
' (see SUB_BEGIN_CRITICAL_SECTION)
'***************************************************************
SUB SUB_END_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB

'***************************************************************
' Initialisation of a digital I/O module (channel 0-15) 
'  card : dip switch adress
' value : each bit corresponds to a channel
'     0 = input
'     1 = output
'***************************************************************
SUB DIGPROG1(card,value)
DIM adr, old as integer
PRECALC
  adr = 32 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    old = peek( DHX )
  SUB_END_CRITICAL_SECTION
    nop_t9
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR, adr )
    nop_t9
    poke( DH , old AND 0FFFFH )
    nop_t9
    poke_nop( DLX, value AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Initialisation of a digital I/O module (channel 16-31) 
' card : dip switch adress
' value : each bit corresponds to a channel
'     0 = input
'     1 = output
'***************************************************************
SUB DIGPROG2(card,value)
  DIM adr,old as integer
PRECALC
  adr = 32 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    old = peek( DLX )
  SUB_END_CRITICAL_SECTION
   nop_t9
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr )
    nop_t9
    poke( DL , old AND 0FFFFH )
    nop_t9
    poke_nop( DHX , value AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB



'***************************************************************
' Reads the digital inputs (channel 0 - 15) 
' card : dip switch adress
'***************************************************************
FUNCTION DIGIN_WORD1(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    DIGIN_WORD1 = peek(DLX)
  SUB_END_CRITICAL_SECTION
  nop_t9
ENDFUNCTION


'***************************************************************
' Reads the digital inputs (channel 16 - 31) 
' card : dip switch adress
'***************************************************************
FUNCTION DIGIN_WORD2(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    DIGIN_WORD2 = peek(DHX)
  SUB_END_CRITICAL_SECTION
  nop_t9
ENDFUNCTION


'***************************************************************
' Reads the digital inputs (channel 0 - 31) 
' card : dip switch adress
'***************************************************************
FUNCTION DIGIN_LONG(card) AS LONG
  DIM adr as integer
PRECALC
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    DIGIN_LONG = Shift_Left(PEEK(DH),16)+PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Reads the digital inputs (channel 0 - 31) 
' card : dip switch adress
' only for modules newer 1/2001 and ADSP CPU
'***************************************************************
FUNCTION DIGIN_LONG_F(card) AS LONG
  DIM adr as integer
  adr = 16 OR (SHIFT_LEFT(card,8))
 
 SUB_BEGIN_CRITICAL_SECTION  
    poke_nop(ADRD,ADR)
    Digin_long_F=PEEK(D32)
 SUB_END_CRITICAL_SECTION
 nop_t9
ENDFUNCTION


'***************************************************************
' Sets the digital outputs (channel 0 - 15) 
' card : dip switch adress
' value : each bit corresponds to a channel
'***************************************************************
SUB DIGOUT_WORD1(card,value)
  DIM adr as integer
PRECALC
  adr = SHIFT_LEFT(card,8)
  SUB_BEGIN_CRITICAL_SECTION
   poke(ADWR , adr )
   nop_t9
PRECALC
   poke_nop( DLX , value AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Sets the digital outputs (channel 16 - 31) 
' card : dip switch adress
' value : each bit corresponds to a channel
'***************************************************************
SUB DIGOUT_WORD2(card,value)
  DIM adr as integer
PRECALC
  adr = 1 OR SHIFT_LEFT(card,8)
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr )
    nop_t9
PRECALC
    poke_nop( DHX , value AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Sets the digital outputs (channel 0 - 31) 
' card : dip switch adress
' value : each bit corresponds to a channel
'***************************************************************
SUB DIGOUT_LONG(card,value)
  DIM adr as integer
PRECALC
  adr = 2 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr )
    nop_t9
PRECALC
    poke( DH , Shift_Right(value,16) AND 0FFFFH )
    nop_t9
PRECALC
    poke_nop( DLX , value AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Sets the digital outputs (channel 0 - 31) 
' card : dip switch adress
' value : each bit corresponds to a channel
' only for modules newer 1/2001 and ADSP CPU
'***************************************************************
SUB DIGOUT_long_F(card,value)
  DIM adr as integer
  ADR=2h OR (SHIFT_LEFT(card,8))

  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADR)
    NOP_T9
    Poke_NOP(D32,value)
  SUB_END_CRITICAL_SECTION
ENDSUB

'***************************************************************
' read back of the output value of the digital
' outputs (channel 0 - 15)) 
' card : dip switch adress
'***************************************************************
FUNCTION GET_DIGOUT_WORD1(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = SHIFT_LEFT(card,8)
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    GET_DIGOUT_WORD1 = peek(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Sets and resets selected digital outputs
' card : dip switch adress
' set  : Bitstring indicating the outputs which should be set
' reset: Bitstring indicating the outputs which should be reset
'***************************************************************
Sub DIGOUT_BITS(card,set,reset)
dim old as long

' getting actual value and manipulating Bits
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, SHIFT_LEFT(card,8))
    old = (((Shift_Left(PEEK(DH),16)+PEEK(DLX)) or set) and not(reset))
  SUB_END_CRITICAL_SECTION

' writing to output
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR, SHIFT_LEFT(card,8) or 2) 
    nop_t9
    poke(DH , Shift_Right(old,16) AND 0FFFFH )
    nop_t9
    poke_nop(DLX , old AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
endsub


'***************************************************************
' Sets and resets selected digital outputs
' card : dip switch adress
' set  : Bitstring indicating the outputs which should be set
' reset: Bitstring indicating the outputs which should be reset
' only for DIO32RB and ADSP CPU
'***************************************************************
Sub DIGOUT_BITS_F(card,set,reset)
dim adr as long
  	ADR=5 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADR)
    NOP_T9
    Poke_NOP(D32,reset)
  SUB_END_CRITICAL_SECTION

	dec ADR

  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADR)
    NOP_T9
    Poke_NOP(D32,set)
  SUB_END_CRITICAL_SECTION
endsub


'***************************************************************
' read back of the output value of the digital
' outputs (channel 16 - 31)) 
' card : dip switch adress
'***************************************************************
FUNCTION GET_DIGOUT_WORD2(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = SHIFT_LEFT(card,8)
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    GET_DIGOUT_WORD2 = peek(DHX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' read back of the output value of the digital
' outputs (channel 0 - 31)) 
' card : dip switch adress
'***************************************************************
FUNCTION GET_DIGOUT_LONG(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = SHIFT_LEFT(card,8)
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    GET_DIGOUT_LONG = Shift_Left(PEEK(DH),16)+PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Sets or resets one channel of a digital output  
' card    : dip switch adress
' channel : channel (0..31)
' value   : 0 = reset channel
'           1 = set channel
'***************************************************************

SUB DIGOUT(card,channel,value)
  DIM adr, old, new as integer
PRECALC
  adr = SHIFT_LEFT(card,8)
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    IF (channel<16) THEN
      old = peek(DLX)
      SUB_END_CRITICAL_SECTION
      IF (value=0) THEN
        new = old AND (NOT(SHIFT_LEFT(1,channel)))
      ELSE
        new = old OR SHIFT_LEFT(1,channel)
      ENDIF
      nop_t9
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR, adr)
      nop_t9
      poke_nop(DLX, new)
    SUB_END_CRITICAL_SECTION
  ELSE       
    old = peek(DHX)
    SUB_END_CRITICAL_SECTION
    IF (value=0) THEN
      new = old AND (NOT(SHIFT_LEFT(1,(channel-16))))
    ELSE
      new = old OR SHIFT_LEFT(1,(channel-16))
    ENDIF
    nop_t9
    SUB_BEGIN_CRITICAL_SECTION
      poke(ADWR, adr+1)
      nop_t9
      poke_nop(DHX, new)
    SUB_END_CRITICAL_SECTION
  ENDIF 
ENDSUB


'***************************************************************
' Sets or resets one channel of a digital output  
' card    : dip switch adress
' channel : channel (0..31)
' value   : 0 = reset channel
'           1 = set channel
' only for DIO32RB and ADSP CPU
'***************************************************************
SUB DIGOUT_F(card,channel,value)
DIM adr as integer
dim value2 as long

  ADR=(5h-value) OR (SHIFT_LEFT(card,8))
  value2=shift_left(1,channel)
	
  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADR)
    NOP_T9
    Poke_NOP(D32,value2)
  SUB_END_CRITICAL_SECTION

ENDSUB


'***************************************************************
' latches the digital I/O card. 
' Inputs ars latched in the input registers
' Outputs ars set according to the output register.             
' card : dip switch adress
'***************************************************************
SUB DIG_LATCH(card)
  DIM adr as integer
PRECALC
  adr = 22 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR, adr)
    nop_t9
    poke_nop(DLX , 0)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' reads the input latch register (channel 0 - 15)
' card : dip switch adress
'***************************************************************
FUNCTION DIG_READLATCH1(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = 20 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    DIG_READLATCH1 = peek(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' reads the input latch register (channel 16 - 31)
' card : dip switch adress
'***************************************************************
FUNCTION DIG_READLATCH2(card) AS INTEGER
  DIM adr as integer
PRECALC
  adr = 20 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    DIG_READLATCH2 = peek(DHX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION

'***************************************************************
' sets output register (channel 0 - 31)
' card : dip switch adress
' value : each bit corresponds to a channel
'***************************************************************
SUB DIG_WRITELATCH32(card,value)
  DIM adr as integer
PRECALC
  adr = 18 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr)
    nop_t9
PRECALC
    poke( DH , Shift_Right(value,16) AND 0FFFFH )
    nop_t9
PRECALC
    poke_nop( DLX , value AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' sets output register (channel 0 - 15)
' card : dip switch adress
' value : each bit corresponds to a channel
'ATTENTION: Do not use in combination with DIG_WRITELATCH2
'***************************************************************
SUB DIG_WRITELATCH1(card,value)
  DIM adr as integer
PRECALC
  adr = 18 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr)
    nop_t9
    poke_nop( DLX , value)
  SUB_END_CRITICAL_SECTION
ENDSUB

'***************************************************************
' sets output register (channel 16 - 31)
' card : dip switch adress
' value : each bit corresponds to a channel
'ATTENTION: Do not use in combination with DIG_WRITELATCH1
'***************************************************************
SUB DIG_WRITELATCH2(card,value)
  DIM adr as integer
PRECALC
  adr = 18 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr)
    nop_t9
    poke_nop( DHX , value)
  SUB_END_CRITICAL_SECTION
ENDSUB



'***************************************************************
'
' The following functions and procedures
' are for accessing counter modules. 
'
'***************************************************************


'***************************************************************
'activate / deaktivate counter 
' card : dip switch adress
' value : each bit corresponds to a counter
'***************************************************************
SUB CNT_ENABLE(card,value)
  DIM adr as integer
PRECALC
  adr = 20 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr )
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
'reset counter 
' card : dip switch adress
' value : each bit corresponds to a counter
'***************************************************************
SUB CNT_CLEAR(card,value)
  DIM adr as integer
PRECALC
  adr = 18 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop(DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB

'***************************************************************
'latch couner value to register 
' card : dip switch adress
' value : each bit corresponds to a counter
'***************************************************************
SUB CNT_LATCH(card,value)
  DIM adr as integer
PRECALC
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
'set modus for counter
' card : dip switch adress
' value : each bit corresponds to a counter
'***************************************************************
SUB CNT_SETMODE(card,value)
  DIM adr as integer
PRECALC
  adr = 22 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB

'***************************************************************
' set modus for a counter
' card : dip switch adress
' counter : number of the counter
' value : 0 = quadrature encoder input
'         1 = forward / backward counter
'         2 = PW input
'***************************************************************
SUB CO4_SETMODE(card,counter,value)
  DIM adr1 as integer
  DIM adr2 as integer
  DIM mode1 as long
  DIM mode2 as long
  DIM readback1 as long
  DIM readback2 as long
PRECALC
  adr1 = 22 OR (SHIFT_LEFT(card,8))
  adr2 = adr1 + 1
  mode1 = shift_left(value and 1, counter-1)
  mode2 = shift_left(shift_right((value and 2),1), counter-1)

  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD , adr1)
    readback1 = PEEK(DLX) and not (shift_left(1, counter-1)) 
  SUB_END_CRITICAL_SECTION
  nop_t9

  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD , adr2)
    readback2 = PEEK(DLX) and not( shift_left(1, counter-1)) 
  SUB_END_CRITICAL_SECTION

  mode1 = mode1 or readback1  
  mode2 = mode2 or readback2  

  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr1)
    nop_t9
    poke_nop( DLX , mode1)           
  SUB_END_CRITICAL_SECTION
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr2)
    nop_t9
    poke_nop( DLX , mode2)           
  SUB_END_CRITICAL_SECTION
ENDSUB




'***************************************************************
'read latch register 32 Bit
' card : dip switch adress
' number : number of the counter
' remark: It is checked if a new counter value had been 
'         latched between reading the high-word and the
'         low word. In this case it will be read again. 
'         (hardware latch)
'***************************************************************
FUNCTION CNT_READLATCH32(card,number) AS INTEGER
  DIM hadr, ladr AS INTEGER
  DIM old_hword, old_lword AS INTEGER
  DIM hword, lword AS INTEGER

PRECALC
  hadr = (2*number-1) OR (SHIFT_LEFT(card,8))
PRECALC
  ladr = (2*number-2) OR (SHIFT_LEFT(card,8))
  DO
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD , ladr)
      old_lword = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD , hadr)
      old_hword = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD , ladr)
      lword = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD , hadr)
      hword = PEEK(DLX)
    SUB_END_CRITICAL_SECTION
  UNTIL ((old_lword = lword) AND (old_hword = hword))
  CNT_READLATCH32 = SHIFT_LEFT(hword, 16) + (lword AND 0FFFFH)
ENDFUNCTION

'**************************************************************
' reads latch register 32 Bit
' card : dip switch adress
' number : number of the counter
'**************************************************************
FUNCTION CO4_READLATCH(card,number) AS INTEGER
 DIM adr as INTEGER
  adr = (number-1) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD , adr)
    CO4_READLATCH = PEEK(D32)
  SUB_END_CRITICAL_SECTION
  nop_t9
ENDFUNCTION



'***************************************************************
' only for moduls newer than 08/2002
' set modus of the 3. PWM-Register and
' set destination of the softwarelatch
' card : dip switch adress
' value :  bit 0-3 each bit corresponds to a counter (3. PWM-Register)
'          0->latch with high-edge (default)
'          1->latch with low-edge
'          bit 4-7 each bit corresponds to a counter (softwarelatch)
'          0->latch into low-register (default)
'          1->latch into high-register
'***************************************************************
SUB CO4_SET_LATCHMODE(card,value)
  DIM adr as integer
  adr = 25 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB



'***************************************************************
' read latch register 16 Bit
' card : dip switch adress
' number : number of the counter
'***************************************************************
FUNCTION CNT_READLATCH16(card,number) AS INTEGER
  DIM adr as integer
  IF (number<9) THEN 
PRECALC
    adr = (2*number-2) OR (SHIFT_LEFT(card,8))
  ELSE
PRECALC
    adr = (2*number-17) OR (SHIFT_LEFT(card,8))
  ENDIF
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    CNT_READLATCH16 = PEEK(DLX) AND 0FFFFH           
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' read counter value 32 Bit
'   card : dip switch adress
' number : number of the counter
'***************************************************************
FUNCTION CNT_READ32(card,number) AS INTEGER
  DIM adr, hword as integer
PRECALC
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop( DLX , SHIFT_LEFT(1,(number-1)))   'latch counter
  SUB_END_CRITICAL_SECTION
PRECALC
  adr = (2*number-1) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    hword = Shift_Left(PEEK(DLX),16)            'read HighWord
  SUB_END_CRITICAL_SECTION
PRECALC
  adr = (2*number-2) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    CNT_READ32 = hword + (PEEK(DLX) AND 0FFFFH) 'read LowWord
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'**************************************************************
' read counter value 32 Bit (new counter board)
' card : dip switch adress
' number : number of the counter
'**************************************************************
FUNCTION CO4_READ(card,number) AS INTEGER
  DIM adr as integer
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop( DLX , SHIFT_LEFT(1,(number-1)))    'latch counter
  SUB_END_CRITICAL_SECTION
PRECALC
  adr = (number-1) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    CO4_READ = PEEK(D32)                     'read 32 Bit-value
  SUB_END_CRITICAL_SECTION
  nop_T9
ENDFUNCTION



'***************************************************************
' read counter value 16 Bit
'   card : dip switch adress
' number : number of the counter
'***************************************************************
FUNCTION CNT_READ16(card,number) AS INTEGER
  DIM adr, hword as integer
PRECALC
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr )
    nop_t9
    poke_nop( DLX , SHIFT_LEFT(1,(number-1)))   'latch counter
  SUB_END_CRITICAL_SECTION
  IF (number<9) THEN 
PRECALC
    adr = (2*number-2) OR (SHIFT_LEFT(card,8))
  ELSE
PRECALC
    adr = (2*number-17) OR (SHIFT_LEFT(card,8))
  ENDIF
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    CNT_READ16 = PEEK(DLX) AND 0FFFFH            'read LowWord
  SUB_END_CRITICAL_SECTION
ENDFUNCTION

'**************************************************************
' reads the status of a counter input 
' card : dip switch adress
' counter : number of the counter
'**************************************************************
FUNCTION CO4_GETSTATUS(card,counter) AS long
  DIM adr as long
  adr = (27 + counter) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr)
     CO4_GETSTATUS = PEEK(D32)           'read 32 Bit-value
  SUB_END_CRITICAL_SECTION
  nop_T9
ENDFUNCTION

'**************************************************************
' resets tihe error bits of the status register
' card : dip switch adress
' value : bitcombination ; each bit corresponds with counter
'**************************************************************
SUB CO4_RESETSTATUS(card,value) AS long
  DIM adr as integer
  adr = 27 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr)
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB


'**************************************************************
' enables the hardware clear input of a counter
' card : dip switch adress
' value : bitcombination ; each bit corresponds with counter
'**************************************************************
SUB CO4_CLEARENABLE(card,value) AS long
  DIM adr as integer
  adr = 24 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr)
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB

'**************************************************************
' enables the hardware latch input of a counter
' card : dip switch adress
' value : bitcombination ; each bit corresponds with counter
'**************************************************************
SUB CO4_LATCHENABLE(card,value) AS long
  DIM adr as integer
  adr = 26 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr)
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB

'**************************************************************
' read SSI encoder value 32 Bit (new counter board)
' card : dip switch adress
' counter : number of the counter
'**************************************************************
FUNCTION SSI_READ(card,counter) AS long
  DIM adr as long
  adr = (34 + counter) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    SSI_READ = PEEK(D32)            'read 32 Bit-value
  SUB_END_CRITICAL_SECTION
  nop_T9
ENDFUNCTION

'**************************************************************
' sets the number of databits for the SSI Interface
' card : dip switch adress
' counter : number of the counter
' value : number of bits
'**************************************************************
SUB SSI_SET_Bits(card,counter,value)
  DIM adr as integer
PRECALC
  adr = (36 + counter) OR (SHIFT_LEFT(card,8))
 
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR , adr)
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB

'**************************************************************
' sets frequency of the SSI clock
' card : dip switch adress
' value : frequency = 10MHZ / value
'**************************************************************
SUB SSI_Set_Clock(card,value)
  DIM adr as integer
PRECALC
  adr = 34 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr)
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB


'**************************************************************
' Starts the SSI interface
' card : dip switch adress
' value : Bitcombination each bit corresponts to one counter
'**************************************************************
SUB SSI_START(card,value)
  DIM adr as integer
  Dim value2 as long

  adr = 17 OR (SHIFT_LEFT(card,8))

  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr)
    value2 = peek(DLX)
  SUB_END_CRITICAL_SECTION
  
  value2=(value and 03H)or value2
   
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr)
    nop_t9
    poke_nop(DLX , value2)
  SUB_END_CRITICAL_SECTION
ENDSUB



'*************************************************************
' Stets the SSI mode
' card : dip switch adress
' value : Bitcombination each bit corresponts to one counter
'       0 = single start mode
'       1 = continuous start mode
'*************************************************************
sub SSI_MODE(card,value)
dim adr as long
dim value2 as long

value2=value AND 03H
adr = 17 OR (SHIFT_LEFT(card,8))

SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr)
    nop_t9
    poke_nop(DLX , (shift_left(value2,2)))
SUB_END_CRITICAL_SECTION

endsub

'*************************************************************
' Reads the SSI status
' card : dip switch adress
' counter : number of the SSI counter
' return value : 0 = SSI value compleated
'                1 = SSI transfer running
'*************************************************************
FUNCTION SSI_STATUS(card,counter) AS long
 dim adr as long
 dim value2 as long
 adr = 17 OR (SHIFT_LEFT(card,8))

 SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr)
    value2 = peek(DLX)
 SUB_END_CRITICAL_SECTION
 
 value2=shift_right(value2,(counter-1))
 ssi_status=value2 AND 01H
ENDFUNCTION


'***************************************************************
' sets and updates the PWM-4 modul
'   card : dip switch adress
' number : number of the output
'     prescaler : value 0,...,7 corresponds to division by 2^0,...,2^7
'     LOW     : Number of cycles after the prescaler for LOW time
'     HIGH     : Number of cycles after the prescaler for HIGH time
'***************************************************************
SUB PWM_SET(card,number,prescaler,LOW,HIGH)
  DIM adr_t, adr_l, adr_h AS INTEGER
PRECALC
  adr_t=(number*2-1) OR (SHIFT_LEFT(card,8))
PRECALC
  adr_l=(number*2+6) OR (SHIFT_LEFT(card,8))
PRECALC
  adr_h=(number*2-2) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_t)
    nop_t9
    poke_nop(DLX,prescaler)
  SUB_END_CRITICAL_SECTION
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_l)
    nop_t9
    poke_nop(DLX,LOW)
  SUB_END_CRITICAL_SECTION
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_h)
    nop_t9
    poke_nop(DLX,HIGH)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' enable a output of the PWM module
'   card : dip switch adress
' number : number of the output
'***************************************************************
SUB PWM_ENABLE(card,number)
  DIM adr_en, adr_clr AS INTEGER
PRECALC
  adr_clr=18 OR (SHIFT_LEFT(card,8))
PRECALC
  adr_en=20 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_clr)
    nop_t9
    poke_nop(DLX,SHIFT_LEFT(1,number))
  SUB_END_CRITICAL_SECTION
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_en)
    nop_t9
    poke_nop(DLX,number)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
'External Latch enable/disable 
' card  : dip switch adress
' value : 1 = enable
'         0 = disable 
'***************************************************************
SUB EXTLCH_ENABLE(card,value)
  DIM adr as integer
PRECALC
  adr = 24 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR , adr )
    nop_t9
    poke_nop( DLX , value)           
  SUB_END_CRITICAL_SECTION
ENDSUB



'***************************************************************
' set/reset a output of the PWM modul
'   card : dip switch adress
' number : number of the output
'value   : 0 = output voltage = 0V
'          1 = output voltage = external voltage
'***************************************************************
SUB PWM_OUT(card,number,value)
DIM adr_clr, adr_upd AS INTEGER
PRECALC
  adr_clr=18 OR (SHIFT_LEFT(card,8))
PRECALC
  adr_upd=24 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_clr)
    nop_t9
    poke_nop(DLX,SHIFT_LEFT(1,number-1))
  SUB_END_CRITICAL_SECTION
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr_upd)
    nop_t9
    poke_nop(DLX,SHIFT_LEFT(1,number-1))
  SUB_END_CRITICAL_SECTION
  PWM_SET(card,number,0,1-value,value)
ENDSUB


'*********************************************************************
' The following functions and procedures
' are for accessing the STORAGE modules. 
'*********************************************************************

'*********************************************************************
' Reads the status word from the glue logic.
'  card: module address
'  status|     |  |  |  |  ||   |   |    |    ||     |    |    |     |
'   bits |31:12|11|10|09|08|| 07| 06| 05 | 04 || 03  | 02 | 01 | 00  |
'  ------|-----|--|--|--|--||---|---|----|----||-----|----|----|-----|
'        |     |           ||   |   | =1 | =1 || =1  | =1 | =1 | =1  |
'        | NA  |           ||*NA|*NA|RE- |DATA||DATA |BUSY|ERR-|Media|
'        |     |           ||   |   |SET |wri-|| can |    | OR | in  |
'        |     |           ||   |   |    |tten|| be  |    |    |Slot |
'        |     |           ||   |   |    |    ||read |    |    |     |
'               \          /
'                0  0  0  1  = 1d : Time-Out READY-Signal
'                0  0  1  0  = 2d : Time-Out WAIT-Signal
'                0  0  1  1  = 3d : Media was removed
'                0  1  0  0  = 4d : Error at READY
'                0  1  0  1  = 5d : Time-Out READY
'                0  1  1  0  = 6d : Error at DRQ (Data ReQuest)
'                0  1  1  1  = 7d : Time-Out DRQ (Data ReQuest)
'                1  0  0  0  = 8d : Media not inserted
'	* = Might be set by other function calls
'*********************************************************************
FUNCTION MEDIA_STAT(card) AS LONG
	SUB_BEGIN_CRITICAL_SECTION  
	POKE_NOP(ADRD,3 OR SHIFT_LEFT(card,8))
	MEDIA_STAT = PEEK(D32)
	SUB_END_CRITICAL_SECTION
	nop_t9
ENDFUNCTION

'*********************************************************************
' Reads a 32 bit LONG value from the glue logic which was previously
' read from the media.
'  card: module address
'*********************************************************************
FUNCTION MEDIA_RD_DAT(card) AS LONG
	SUB_BEGIN_CRITICAL_SECTION  
	POKE_NOP(ADRD,15 OR SHIFT_LEFT(card,8))
	MEDIA_RD_DAT = PEEK(D32)
	SUB_END_CRITICAL_SECTION
	nop_t9
ENDFUNCTION

'*********************************************************************
' Writes an instruction word to the glue logic.
'  card:   module address (LONG)
'  code:   instruction code (LONG), possible codes are:
'          6 - write sectors
'          8 - read identifier of media (256 bytes long)
'          9 - read sectors
'  sector: sector number (LONG)
'  cnt:    sector count (LONG: 1...12)
'*********************************************************************
SUB MEDIA_WR_CMD(card,code,sector,cnt)
	SUB_BEGIN_CRITICAL_SECTION
	POKE(ADWR,code OR SHIFT_LEFT(card,8))
	NOP_T9
	POKE_NOP(D32,(sector OR SHIFT_LEFT(cnt,28)))
	SUB_END_CRITICAL_SECTION
ENDSUB

'*********************************************************************
' Writes one 32 bit data word to the SRAM of the glue logic.
'  card : module address (LONG)
'  daten: 32 bit data word (LONG or FLOAT)
'*********************************************************************
SUB MEDIA_WR_DAT(card,daten)
	SUB_BEGIN_CRITICAL_SECTION
	POKE(ADWR,7 OR SHIFT_LEFT(card,8))
	NOP_T9
	POKE_NOP(D32,daten)
	SUB_END_CRITICAL_SECTION
ENDSUB

'*********************************************************************
' Sends a RESET command to the media for initialization or recovering
' from unexpected fault conditions.
'  card: module address (LONG)
'*********************************************************************
SUB MEDIA_RST(card)
	SUB_BEGIN_CRITICAL_SECTION
	POKE(ADWR,20 OR SHIFT_LEFT(card,8))
	NOP_T9
	POKE_NOP(D32,0)
	SUB_END_CRITICAL_SECTION
ENDSUB

'*********************************************************************
' Waits for respond of the media for a specified amount of time.
'  card: module address (1...255)
'  term: Abort condition (as described in MEDIA_STAT())
'  time: Abort time in 100s steps
'  return value : Media status as described in MEDIA_STAT() (LONG) or
'                 80h -> Media does not respond (time-out)
'*********************************************************************
FUNCTION MEDIA_WFR(card,term,time) AS LONG
DIM t1, t2, t3, stat, ret AS LONG
	t1=READ_TIMER()
	t3=time
	#IF PROZESSOR=T10 THEN
		t3=t3*2
	#ENDIF
	DO
		t2=READ_TIMER()
		stat=MEDIA_STAT(card)
		IF ((stat AND 1)=0) THEN	'media not inserted
			ret=stat
			stat=0
		ELSE
			IF ((t2-t1)>t3) THEN	'time-out
				MEDIA_RST(card)
				ret=80h
				stat=0
			ELSE
				ret=stat
			ENDIF
		ENDIF
	UNTIL ((stat AND term)=0h)
	MEDIA_WFR=ret
ENDFUNCTION

'*********************************************************************
' Writes blocks (1...12 with 128 LONGs each) of data to media.
'  card   : Module address (LONG: 1...255)
'  f_info : Name of array that holds the file informations
'  file   : File number (LONG: 1...10)
'  s_sec  : Rel. sector number of start sector in file (LONG: 1...m)
'  s_cnt  : Number of blocks with 128 LONGs each (LONG: 1...12)
'  array  : Source array to copy data from
'  idx    : First array element to copy from (LONG: 1...n)
'  return value : Media status as described in MEDIA_STAT() (LONG) or
'                 40h -> number of blocks exceeding EOF,
'                        no data written to media
'*********************************************************************
FUNCTION MEDIA_WR_BLK_L(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
DIM i, first, last, stat, type AS LONG
	last=f_info[file*2+2]
	first=f_info[file*2+1]
	IF ((last-first+2)<(s_sec+s_cnt)) THEN
		stat=40h			'Block will be written beyond EOF!!!
	ELSE
		stat=MEDIA_WFR(card,26h,150000)
		MEDIA_WR_CMD(card,6,(s_sec-1+first),s_cnt)
		FOR i=1 TO s_cnt*128
			MEDIA_WR_DAT(card,array[idx-1+i])
		NEXT i
		stat=MEDIA_STAT(card)
	ENDIF
	MEDIA_WR_BLK_L=stat
ENDFUNCTION

FUNCTION MEDIA_WR_BLK(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
	MEDIA_WR_BLK = MEDIA_WR_BLK_L(card,f_info,file,s_sec,s_cnt,array,idx)
ENDFUNCTION

'*********************************************************************
' Writes blocks (1...12 with 128 FLOATs each) of data to media.
'  card   : Module address (LONG: 1...255)
'  f_info : Name of array that holds the file informations
'  file   : File number (LONG: 1...10)
'  s_sec  : Rel. sector number of start sector in file (LONG: 1...m)
'  s_cnt  : Number of blocks with 128 FLOATs each (LONG: 1...12)
'  array  : Source array to copy data from
'  idx    : First array element to copy from (LONG: 1...n)
'  return value : Media status as described in MEDIA_STAT() (LONG) or
'                 40h -> number of blocks exceeding EOF,
'                        no data written to media
'*********************************************************************
FUNCTION MEDIA_WR_BLK_F(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
DIM i, first, last, stat, type AS LONG
	last=f_info[file*2+2]
	first=f_info[file*2+1]
	IF ((last-first+2)<(s_sec+s_cnt)) THEN
		stat=40h			'Block will be written beyond EOF!!!
	ELSE
		stat=MEDIA_WFR(card,26h,150000)
		MEDIA_WR_CMD(card,6,(s_sec-1+first),s_cnt)
		stat=MEDIA_WFR(card,26h,150000)
		FOR i=1 TO s_cnt*128
			MEDIA_WR_DAT(card,CAST_FLOATTOLONG(array[idx-1+i]))
		NEXT i
		stat=MEDIA_STAT(card)
	ENDIF
	MEDIA_WR_BLK_F=stat
ENDFUNCTION

'*********************************************************************
' Reads blocks (1...12 with 128 LONGs each) of data from media.
'  card   : Module address (LONG: 1...255)
'  f_info : Name of array that holds the file informations
'  file   : File number (LONG: 1...10)
'  s_sec  : Rel. sector number of start sector in file (LONG: 1...n)
'  s_cnt  : Number of blocks with 128 LONGs/FLOATs each (LONG: 1...12)
'  array  : Destination array to copy data to
'  idx    : First array element to copy to (LONG: 1...n)
'  return value : Media status as described in MEDIA_STAT() (LONG) or
'                 40h -> number of blocks exceeding EOF,
'                        no data read from media
'*********************************************************************
FUNCTION MEDIA_RD_BLK_L(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
DIM i, first, last, stat AS LONG
	last=f_info[file*2+2]
	first=f_info[file*2+1]
	IF ((last-first+2)<(s_sec+s_cnt)) THEN
		stat=40h			'Block will be read beyond EOF!!!
	ELSE
		stat=MEDIA_WFR(card,26h,150000)
		MEDIA_WR_CMD(card,9,(s_sec-1+first),s_cnt)
		stat=MEDIA_WFR(card,26h,150000)
		FOR i=1 TO s_cnt*128
			array[idx-1+i]=MEDIA_RD_DAT(card)
		NEXT i
		stat=MEDIA_STAT(card)
	ENDIF
	MEDIA_RD_BLK_L=stat
ENDFUNCTION

'*********************************************************************
' Reads blocks (1...12 with 128 FLOATs each) of data from media.
'  card   : Module address (LONG: 1...255)
'  f_info : Name of array that holds the file informations
'  file   : File number (LONG: 1...10)
'  s_sec  : Rel. sector number of start sector in file (LONG: 1...n)
'  s_cnt  : Number of blocks with 128 LONGs/FLOATs each (LONG: 1...12)
'  array  : Destination array to copy data to
'  idx    : First array element to copy to (LONG: 1...n)
'  return value : Media status as described in MEDIA_STAT() (LONG) or
'                 40h -> number of blocks exceeding EOF,
'                        no data read from media
'*********************************************************************
FUNCTION MEDIA_RD_BLK_F(card,f_info[],file,s_sec,s_cnt,array[],idx) AS LONG
DIM i, first, last, stat AS LONG
	last=f_info[file*2+2]
	first=f_info[file*2+1]
	IF ((last-first+2)<(s_sec+s_cnt)) THEN
		stat=40h			'Block will be read beyond EOF!!!
	ELSE
		stat=MEDIA_WFR(card,26h,150000)
		MEDIA_WR_CMD(card,9,s_sec-1+first,s_cnt)
		stat=MEDIA_WFR(card,26h,150000)
		FOR i=1 TO s_cnt*128
			array[idx-1+i]=CAST_LONGTOFLOAT(MEDIA_RD_DAT(card))
		NEXT i
		stat=MEDIA_STAT(card)
	ENDIF
	MEDIA_RD_BLK_F=stat
ENDFUNCTION

'*********************************************************************
' Resets media and reads from sector 2 the file information table,
' where all start and end sectors of the data files are stored.
' Unable to read sector 2 if RESET, BUSY, ERROR, no media in slot!
'  card  : module address (LONG: 1...255)
'  array : Name of array (>=22 elements) to store start & end sectors
'  return value : Media status as described in MEDIA_STAT() (LONG)
'*********************************************************************
FUNCTION MEDIA_RD_FILEINFO(card,array[]) AS LONG
	DIM n, stat AS LONG
	stat=MEDIA_STAT(card)
	IF ((stat AND 1h)=1h) THEN
		MEDIA_RST(card)
		stat=MEDIA_WFR(card,26h,1200)
		MEDIA_WR_CMD(card,9,2,1)
		stat=MEDIA_WFR(card,26h,150000)
		FOR n=1 TO 22
			array[n]=MEDIA_RD_DAT(card)
		NEXT n
	ENDIF
	MEDIA_RD_FILEINFO=stat
ENDFUNCTION

'********************** Real-Time-Clock (RTC): ***********************
'The 32 bit value holds the information for year, month, day,
'hour, minute and second in the following manner:
'   bits: | 31:26 | 25:22 | 21:17 | 16:12 | 11:06 | 05:00 |
'   ------+-------+-------+-------+-------+-------+-------+
'         | year  | month |  day  | hour  |minute |second |

'*********************************************************************
' Writes the coded 32 bit word containing the date and time infor-
' mation to the RTC.
'  card: Module address (LONG: 1...255)
'*********************************************************************
SUB RTC_WR(card,value)
	SUB_BEGIN_CRITICAL_SECTION
	POKE(ADWR,16 OR SHIFT_LEFT(card,8))
	NOP_T9
  POKE_NOP(D32,value)
	SUB_END_CRITICAL_SECTION
ENDSUB

'*********************************************************************
' Reads the coded 32 bit word containing the date and time information
' from the RTC.
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_RD(card) AS LONG
	SUB_BEGIN_CRITICAL_SECTION
  POKE_NOP(ADRD,17 OR SHIFT_LEFT(card,8))
  RTC_RD=PEEK(D32)
	SUB_END_CRITICAL_SECTION
	NOP_T9
ENDFUNCTION

'*********************************************************************
' Sets the RTC to the desired value. If any of the entries are not
' valid neither value will be accepted and the RTC remains unchanged!
'  card:   Module address (LONG: 1...255)
'  year:   Last two digits of the year 0...63 (LONG)
'  month:  1...12 (LONG)
'  day:    1...31 (LONG)
'  hour:   0...23 (LONG)
'  minute: 0...59 (LONG)
'  second: 0...59 (LONG)
'*********************************************************************
SUB RTC_SET(card,year,month,day,hour,min,sec)
	DIM val AS LONG
	val=0
	val=SHIFT_LEFT(year AND 3Fh,26)						'Bits 31:26
	val=val OR SHIFT_LEFT(month AND 0Fh,22)		'Bits 25:22
	val=val OR SHIFT_LEFT(day AND 1Fh,17)			'Bits 21:17
	val=val OR SHIFT_LEFT(hour AND 1Fh,12)		'Bits 16:12
	val=val OR SHIFT_LEFT(min AND 3Fh,6)			'Bits 11:06
	val=val OR (sec AND 3Fh)									'Bits 05:00
	RTC_WR(card,val)
ENDSUB

'*********************************************************************
' Reads out the current date and time from the RTC at once.
' Parameters are preferaby LONGs.
'  card:   Module address (LONG: 1...255)
'  year:   Last two digits of the year 0...63 (LONG)
'  month:  1...12 (LONG)
'  day:    1...31 (LONG)
'  hour:   0...23 (LONG)
'  minute: 0...59 (LONG)
'  second: 0...59 (LONG)
'*********************************************************************
SUB RTC_GET(card,year,month,day,hour,min,sec)
	DIM val AS LONG
	val=RTC_RD(card)
	year=SHIFT_RIGHT(val,26) AND 3Fh		'Bits 31:26
	month=SHIFT_RIGHT(val,22) AND 0Fh		'Bits 25:22
	day=SHIFT_RIGHT(val,17) AND 1Fh			'Bits 21:17
	hour=SHIFT_RIGHT(val,12) AND 1Fh		'Bits 16:12
	min=SHIFT_RIGHT(val,6) AND 3Fh			'Bits 11:06
	sec=val AND 3Fh 										'Bits 05:00
ENDSUB

'*********************************************************************
' Reads out the current year from the RTC (2000...2063).
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_GET_YEAR(card) AS LONG
  RTC_GET_YEAR=SHIFT_RIGHT(RTC_RD(card),26)+2000
ENDFUNCTION

'*********************************************************************
' Reads out the current month from the RTC (1...12)
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_GET_MONTH(card) AS LONG
  RTC_GET_MONTH=SHIFT_RIGHT(RTC_RD(card),22) AND 0Fh
ENDFUNCTION

'*********************************************************************
' Reads out the current day from the RTC
' (value ranges from 1...28/29/30/31 depending on month and leapyear)
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_GET_DAY(card) AS LONG
  RTC_GET_DAY=SHIFT_RIGHT(RTC_RD(card),17) AND 1Fh
ENDFUNCTION

'*********************************************************************
' Reads out the current hour from the RTC (0...23, military notation)
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_GET_HOUR(card) AS LONG
  RTC_GET_HOUR=SHIFT_RIGHT(RTC_RD(card),12) AND 1Fh
ENDFUNCTION

'*********************************************************************
' Reads out the current minute from the RTC (0...59)
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_GET_MINUTE(card) AS LONG
  RTC_GET_MINUTE=SHIFT_RIGHT(RTC_RD(card),6) AND 3Fh
ENDFUNCTION

'*********************************************************************
' Reads out the current second from the RTC (0...59)
'  card: Module address (LONG: 1...255)
'*********************************************************************
FUNCTION RTC_GET_SECOND(card) AS LONG
  RTC_GET_SECOND=RTC_RD(card) AND 3Fh
ENDFUNCTION

'*************************************************************
' COMP 16
'*************************************************************
' SET HYSTERESIS SWITCH POINTS
' card : dip switch adress
' channe: channel (1-16)
' valueHIGH switch point to set output bit to 1
' valueLOW switch point to set output bit to 0
'*************************************************************
SUB COMP_SET(card,channel,valueHigh,valueLow)
DIM adr AS INTEGER
DIM CH,HIGH,LOW as INTEGER
 
 adr=20 OR (SHIFT_LEFT(card,8))
 CH=shift_left(((channel-1) AND 0FH),20) 
 HIGH=shift_left((valueHigh AND 3FFH),10)
 LOW=valueLow AND 3FFH
 
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr)
    nop_t9
    poke_nop(D32,(CH OR HIGH OR LOW))
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Reads the digital inputs (channel 0 - 15) 
' card : dip switch adress
'***************************************************************
FUNCTION COMP_DIGIN_WORD(card) AS INTEGER
  DIM adr as integer
  adr = 16 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    COMP_DIGIN_WORD = peek(DLX)
  SUB_END_CRITICAL_SECTION
  nop_t9
ENDFUNCTION

'***************************************************************
' Reads the digital inputs (channel 0 - 7) by diff   
' card : dip switch adress
'***************************************************************
FUNCTION COMP_DIGIN_WORD_DIFF(card) AS LONG
 dim adr as long
 adr = 23 OR (SHIFT_LEFT(card,8))
 SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr)
    COMP_DIGIN_WORD_DIFF = peek(D32)
 SUB_END_CRITICAL_SECTION
 nop_T9
ENDFUNCTION


'*************************************************************
' Reads the analog value, min value or max value
' card : dip switch adress
' channel nummber of channel (1-16)
' select 0 = read value
'				 1 = read min value
'        2 = read max value
'*************************************************************
FUNCTION COMP_READ(card,channel,select) AS long
 dim adr as long
 dim value2 as long
 adr = (23+channel) OR (SHIFT_LEFT(card,8))
 SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr)
    value2 = peek(D32)
 SUB_END_CRITICAL_SECTION
 
 COMP_READ=(shift_right(value2,(10*select))) AND 3FFH
ENDFUNCTION

'*************************************************************
' RESET min / max value (max=0 min=1024)
' card : dip switch adress
' select : each bit corresponds to a channel
'*************************************************************
SUB COMP_RESET(card,select)
DIM adr AS INTEGER
 adr=21 OR (SHIFT_LEFT(card,8))
  
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr)
    nop_t9
    poke_nop(D32,(select))
  SUB_END_CRITICAL_SECTION
ENDSUB

'*************************************************************
' Select the channels to write to the internal FIFO
' card : dip switch adress
' channel : 0= channel 1/2  1= channel 3/4 ...
'*************************************************************
sub COMP_FIFO_SELECT(card,channel)
DIM adr AS INTEGER
 adr=17 OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr)
    nop_t9
    poke_nop(D32,(channel+1))
  SUB_END_CRITICAL_SECTION
endsub


'*************************************************************
' Read FIFOBUFFER[1024] to DATA 
' card : dip switch adress
' channel : 0= channel 1,2  1= channel 3,4 ...
'*************************************************************
sub COMP_FIFO_READ(card,arrayLowChannel,arrayHighChannel)
  DIM adr AS INTEGER
  dim i as long
  dim value as long
  dim select as long

  adr=18 OR (SHIFT_LEFT(card,8))

  'read select for new start
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRd,adr-1)
    nop_t9
    select=peek(Dlx)
  SUB_END_CRITICAL_SECTION
  nop_t9


  'stop write to fifo
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr-1)
    nop_t9
    poke_nop(D32,(0))
  SUB_END_CRITICAL_SECTION

  'set adress
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr)
    nop_t9
    poke_nop(D32,0)
  SUB_END_CRITICAL_SECTION

  'read value
  for i=1 to 1024
    SUB_BEGIN_CRITICAL_SECTION
      poke_nop(ADRD, adr-4)
      value = peek(D32)
    SUB_END_CRITICAL_SECTION
    arrayHighChannel[i]=value AND 0FFFFH
    arrayLowChannel[i]=shift_right(value,16)      
  next

  'start write to fifo
  SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR,adr-1)
    nop_t9
    poke_nop(D32,select)
  SUB_END_CRITICAL_SECTION
endsub






