
#ifndef __LIBADWIN_BITS_H__
#define __LIBADWIN_BITS_H__

/* 
 * Processor constants
 * (These differ from those <linux/adwin.h> defines ...
 */
#define k_proc_t2               2
#define k_proc_t4               4
#define k_proc_t5               5
#define k_proc_t8               8
#define k_proc_t9               9
#define k_proc_t10             10
#define k_proc_t11             11

/*
 * error codes returned from adwin ethernet server
 * (for internal use only)
 */
#define	k_timeout                  5
#define	k_UDPtimeout              -1
#define k_WrongPassword           -5
#define k_TryLater               -10
#define k_DateiFehler            -15
#define k_PaketFehler            -20
#define k_Paketzugross	         -25
#define k_WrongSize              -26
#define k_WrongVersion	         -30
#define k_PaketZuKlein	         -31
#define k_FifoLessData	         -32
#define k_FalscheReihenfolge     -33
#define k_SchonBearbeitet        -40
#define k_RetryUnknown           -41

/*
 * command shortcuts used with adwin ethernet server
 * (for internal use only)
 */
#define k_3plus1		0
#define k_GetPar		1
#define k_Start			2
#define k_Stop			3
#define k_lMemory		5
#define k_SetPar		6
#define k_Clear_Data		9
#define k_GetDataLength		11
#define k_MemoryAll		12
#define k_ClearProcess		14
#define k_ADC			15
#define k_DAC			16
#define k_GetDigin		17
#define k_SetDigout		18
#define k_GetDigout		19
#define k_ClearFifo		21
#define k_GetFifoEmpty		22
#define k_GetFifoCount		23

#define k_LadeBin		4
#define k_GetData		7
#define k_SetData		8
#define k_CreateData		10
#define k_GetParAll		13
#define k_Auslastung		20
#define k_GetFifo		24
#define k_SetFifo		25
#define k_Boot			50
#define k_GetDataTyp		100

#define k_GetDatafast		107

#define k_GetFifo_Retry		124
#define k_SetFifo_Retry		125

#define k_TestVersion		255
#define k_armVersion		1000
#define k_GetDatasmall		207
#define k_GetMem		1000000


#endif // __LIBADWIN_BITS_H__
